unit fuAQBDemoMain;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, ADODB, fuAQBuilder, acAbout;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    miFile: TMenuItem;
    miFileNewItem: TMenuItem;
    miFileOpenItem: TMenuItem;
    miFileCloseItem: TMenuItem;
    miWindow: TMenuItem;
    miHelp: TMenuItem;
    N1: TMenuItem;
    miFileExitItem: TMenuItem;
    miWindowCascadeItem: TMenuItem;
    miWindowTileItem: TMenuItem;
    miWindowArrangeItem: TMenuItem;
    miHelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    miFileSaveItem: TMenuItem;
    miFileSaveAsItem: TMenuItem;
    miEdit: TMenuItem;
    miCutItem: TMenuItem;
    miCopyItem: TMenuItem;
    miPasteItem: TMenuItem;
    miWindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList: TActionList;
    acEditCut: TEditCut;
    acEditCopy: TEditCopy;
    acEditPaste: TEditPaste;
    acFileNew: TAction;
	 acFileSave: TAction;
    acFileExit: TAction;
    acFileOpen: TAction;
    acFileSaveAs: TAction;
    acWindowCascade: TWindowCascade;
    acWindowTileHorizontal: TWindowTileHorizontal;
    acWindowArrangeAll: TWindowArrange;
    acWindowMinimizeAll: TWindowMinimizeAll;
    acHelpAbout: TAction;
    acFileClose: TWindowClose;
    acWindowTileVertical: TWindowTileVertical;
    miWindowTileItem2: TMenuItem;
    ToolBar: TToolBar;
    tbOpen: TToolButton;
    tbSave: TToolButton;
    tsbN1: TToolButton;
    tbCut: TToolButton;
    tbCopy: TToolButton;
    tbPaste: TToolButton;
    tbNew: TToolButton;
    tbsN2: TToolButton;
    tbCascade: TToolButton;
    tbTileHorizontal: TToolButton;
    tbTileVertical: TToolButton;
    ImageList: TImageList;
    N2: TMenuItem;
    miSelectAll: TMenuItem;
    acEditSelectAll: TEditSelectAll;
    tbsN3: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
	 acQueryBuild: TAction;
    acQueryRun: TAction;
    SaveDialog: TSaveDialog;
    miQuery: TMenuItem;
    miQueryBuild: TMenuItem;
    miQueryRun: TMenuItem;
    acVisualSetup: TAction;
    procedure acFileNewExecute(Sender: TObject);
    procedure acFileOpenExecute(Sender: TObject);
    procedure acHelpAboutExecute(Sender: TObject);
    procedure acFileExitExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure acQueryBuildExecute(Sender: TObject);
    procedure acQueryRunExecute(Sender: TObject);
    procedure acFileSaveExecute(Sender: TObject);
    procedure acFileSaveAsExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure CreateQueryBuilder(const FileName: string);
  public
    { Public declarations }
    CurrentQueryBuilder: TfmAQBuilder;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses fuAQBConnect;

procedure TMainForm.CreateQueryBuilder(const FileName: string);
var
	Builder: TfmAQBuilder;
	ADOConnection: TADOConnection;
	DBObjects: TStringList;
	FolderNode: TTreeNode;
	i: Integer;
begin
	ADOConnection := TADOConnection.Create(Self);
	with ADOConnection do try

		with TfmAQBConnect.Create(Self) do try
			if ShowModal <> mrOk
				then Exit;

			ConnectionString := ConnectString;
		finally
			Free;
		end;

		LoginPrompt := False;
		if ConnectionString = '' then Abort;
		Open;
		if not Connected then Abort;

		Builder := TfmAQBuilder.Create(Application);

		Builder.ADOConnection.ConnectionString := ConnectionString;
		DBObjects := TStringList.Create;
		try

			DBObjects.Sorted := True;
			Builder.acADOMetadataProvider.GetTableNames(DBObjects);
			FolderNode := Builder.treeObjects.Items.Add(nil, 'Tables');
			FolderNode.ImageIndex := 2;
			FolderNode.SelectedIndex := 2;
			for i := 0 to DBObjects.Count-1 do
				with Builder.treeObjects.Items.AddChild(FolderNode, DBObjects[i]) do begin
					ImageIndex := 0;
					SelectedIndex := 0;
				end;
			FolderNode.Expand(False);

			DBObjects.Clear;
			Builder.acADOMetadataProvider.GetViewNames(DBObjects);
			FolderNode := Builder.treeObjects.Items.Add(nil, 'Views');
			FolderNode.ImageIndex := 2;
			FolderNode.SelectedIndex := 2;
			for i := 0 to DBObjects.Count-1 do
				with Builder.treeObjects.Items.AddChild(FolderNode, DBObjects[i]) do begin
					ImageIndex := 1;
					SelectedIndex := 1;
				end;
			FolderNode.Expand(False);

		finally
			DBObjects.Free;
		end;

		{$IFNDEF FREE}
		if Pos('SQLOLEDB', Builder.ADOConnection.Provider) = 1
		then begin
			Builder.cbSyntaxProvider.ItemIndex := 1;
			Builder.cbSyntaxProviderChange(nil);
		end
		else if Pos('MySqlProv', Builder.ADOConnection.Provider) = 1
		then begin
			Builder.cbSyntaxProvider.ItemIndex := 2;
			Builder.cbSyntaxProviderChange(nil);
		end;
		{$ENDIF}

		Builder.Caption := FileName;
		if FileExists(FileName)
		then begin
			Builder.editSQL.Lines.LoadFromFile(FileName);
			Builder.QueryBuilder.SQL := Builder.editSQL.Text;
		end;

	finally
		ADOConnection.Free;
   end;
end;

procedure TMainForm.acFileNewExecute(Sender: TObject);
begin
	CreateQueryBuilder('Noname' + IntToStr(MDIChildCount + 1));
end;

procedure TMainForm.acFileOpenExecute(Sender: TObject);
begin
	if OpenDialog.Execute then
		CreateQueryBuilder(OpenDialog.FileName);
end;

procedure TMainForm.acHelpAboutExecute(Sender: TObject);
begin
	with TfAcQBAboutForm.Create(Application) do try
		ShowModal;
	finally
		Free;
	end;
end;

procedure TMainForm.acFileExitExecute(Sender: TObject);
begin
	Close;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
	acQueryBuild.Enabled := False;
	acQueryRun.Enabled := False;
	acFileSave.Enabled := False;
	acFileSaveAs.Enabled := False;
	CurrentQueryBuilder := nil;
end;

procedure TMainForm.acQueryBuildExecute(Sender: TObject);
begin
	if Assigned(CurrentQueryBuilder)
		then CurrentQueryBuilder.IsRun := False;
end;

procedure TMainForm.acQueryRunExecute(Sender: TObject);
begin
	if Assigned(CurrentQueryBuilder)
		then CurrentQueryBuilder.IsRun := True;
end;

procedure TMainForm.acFileSaveExecute(Sender: TObject);
begin
	if Assigned(CurrentQueryBuilder)
	then with CurrentQueryBuilder do begin
		if Pos('Noname', Caption) = 1
		then begin
			acFileSaveAs.Execute;
			Exit;
		end;
		editSQL.Lines.SaveToFile(Caption);
		EditorChanged := False;
	end;
end;

procedure TMainForm.acFileSaveAsExecute(Sender: TObject);
begin
	if SaveDialog.Execute
	then begin
		CurrentQueryBuilder.Caption := SaveDialog.FileName;
		acFileSave.Execute;
	end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
	OpenDialog.InitialDir := ExtractFilePath(Application.ExeName);
	SaveDialog.InitialDir := ExtractFilePath(Application.ExeName);
end;

end.
